/*
    *	This bus implements the easy communication through I2C-DEV
    *   The real I2C-type communication materialized at I2C/SMBUS and I2C-DEV so it just passes requests
    *
    *   Copyright (c)2019 Tóthpál István, istvan@tothpal.eu
    *
    *   TODO: use QT Debug instead of printf
    *   TODO: write tested only with 24c02
*/

#ifndef _I2C_DEV_BUS_
#define _I2C_DEV_BUS_

#include "../i2cbus.h"
#include "../businter.h"

class I2CDevBus : public I2CBus
{
    public:
        I2CDevBus(BusInterface *p = 0);
	    virtual ~I2CDevBus();

	int Open(int port);
	void Close();

	int TestPort(int port);

	int Stop();
	int Reset();

	long Read(int addr, uint8_t *data, long length, int page_size = 0);
	long Write(int addr, const uint8_t *data, long length, int page_size = 0);
	int Start(uint8_t slave);
	int ReadByte(int ack, int lsb = 0);
	int WriteByte(int by, int lsb = 0);
	long StartRead(uint8_t slave, uint8_t *data, long length);
	long StartWrite(uint8_t slave, const uint8_t *data, long length);
	
	void SetDelay();
    
    private:

	int is_16bit_i2c_eprom = 0;
    long epchiptype = 0;
    long epbanksize = 0;

};

#endif
